<?php

# error_reporting(E_ALL);
# ini_set("display_errors", 1);
  
// init timer
$stopwatch = new StopWatch(); 

/*
Plugin Name: sa_development
Description: Provides alterative debug console
Version: 0.1
Author: Shawn Alverson
Author URI: http://www.shawnalverson.com/

*/

$PLUGIN_ID = "sa_development";
$PLUGINPATH = $SITEURL.'plugins/sa_development/';
$sa_url = "http://tablatronix.com/getsimple-cms/sa-dev-plugin/";

# get correct id for plugin
$thisfile=basename(__FILE__, ".php");

# register plugin
register_plugin(
	$thisfile,                  //Plugin id
	'SA Development', 	            //Plugin name
	'0.2', 		                  //Plugin version
	'Shawn Alverson',           //Plugin author
	$sa_url,                    //author website
	'SA Development Suite', //Plugin description
	'',                         //page type - on which admin tab to display
	''                          //main function (administration)
);

// enable only when logged in
if(sa_user_is_admin()){
  add_action('index-posttemplate', 'sa_debugConsole');
  # add_action('footer', 'sa_debugtest'); // debug logging
  add_action('footer', 'sa_debugConsole');
  # add_action('sa_dev_menu','sa_dev_menu_hook'); // debug dev menus hooks
}

// INCLUDES
require_once('sa_development/hooks.php');

// asset queing
// use header hook if older than 3.1
  if(floatval(GSVERSION) < 3.1){
    add_action('header', 'sa_dev_executeheader');
    $owner = "SA_dev_";
  }  
  else{ sa_dev_executeheader(); }


// GLOBALS
$SA_DEV_GLOBALS = array();
$SA_DEV_GLOBALS['show_hooks_front']  = (isset($_REQUEST['sa_shf']) and $_REQUEST['sa_shf']==1) ? true : false;  // print hooks frontend
$SA_DEV_GLOBALS['show_hooks_back']   = (isset($_REQUEST['sa_shb']) and $_REQUEST['sa_shb']==1) ? true : false;  // print hooks backend
$SA_DEV_GLOBALS['bmark_hooks_front'] = (isset($_REQUEST['sa_bhf']) and $_REQUEST['sa_bhf']==1) ? true : false;  // benchmark hooks frontend
$SA_DEV_GLOBALS['bmark_hooks_back']  = (isset($_REQUEST['sa_bhb']) and $_REQUEST['sa_bhb']==1) ? true : false;  // benchmark hooks backend

$SA_DEV_BUTTONS = array();

// INIT
sa_initHookDebug();

// COMPATABILITY
# Backwards Compatability for 3.0 Script Queing
function SA_dev_register_style($handle, $src, $ver){echo '<link rel="stylesheet" href="'.$src.'" type="text/css" charset="utf-8" />'."\n";}
function SA_dev_queue_style($name,$where){}
function SA_dev_register_script($handle, $src, $ver, $in_footer=FALSE){echo '<script type="text/javascript" src="'.$src.'"></script>'."\n";}
function SA_dev_queue_script($name,$where){}

// FUNCTIONS

function sa_getFlag($flag){
  return isset($_REQUEST[$flag]) and $_REQUEST[$flag]==1 ? true : false;
}

function sa_user_is_admin(){
  GLOBAL $USR;
    
  if (isset($USR) && $USR == get_cookie('GS_ADMIN_USERNAME')) {
    return true;
  }
}

function pageIsFrontend() {
  // todo: There might be an existing function for this 
	$path = basename(htmlentities($_SERVER['PHP_SELF'], ENT_QUOTES));
	$file = basename($path,".php");
	return $file == 'index';
}

function sa_debugMenu(){ 
  GLOBAL $SA_DEV_GLOBALS, $SA_DEV_BUTTONS;
    
 	$site = pageIsFrontend() ? 'front' : 'back';
  $sitecode = pageIsFrontend() ? 'f' : 'b';
  $sh = '?'.get_toggleqstring('show_hooks_'.$site,'sa_sh'.$sitecode).'#sa_debug_title';
  $bh = '?'.get_toggleqstring('bmark_hooks_'.$site,'sa_bh'.$sitecode).'#sa_debug_title';
  
  $reset = sa_dev_qstring('sa_sh'.$sitecode);
  $reset = '?'.sa_dev_qstring('sa_bh'.$sitecode,null,$reset);
    
  # debugLog($reset);
  # debugLog($sh);
  # debugLog($bh);
   
  $local_menu = array();
  $local_menu[] = array('title'=>'Reset','url'=> $reset);
  $local_menu[] = array('title'=>'Show Hooks','url'=> $sh,'on'=>$SA_DEV_GLOBALS['show_hooks_'.$site]);
  $local_menu[] = array('title'=>'Time Hooks','url'=> $bh,'on'=>$SA_DEV_GLOBALS['bmark_hooks_'.$site]);

  echo '<div id="sa_dev_menu"><ul>';
  echo sa_dev_makebuttons($local_menu);
  exec_action('sa_dev_menu');  
  if(count($SA_DEV_BUTTONS) > 0){
    echo '<li><b>|</b> </li>';
    echo sa_dev_makebuttons($SA_DEV_BUTTONS,true);
  }  
  echo '</ul></div>';
  
}

function sa_dev_makebuttons($buttons,$custom=false){
  $buttonstr = '';
  $classon = '_on';
  $classcustom = '_custom';
  $id = 0;
  
  foreach($buttons as $button){
    $class = 'class="sa_dev';
    if($custom) $class.= $classcustom;
    if(isset($button['on'])) $class.= $button['on'] ? $classon : ''; 
    $buttonstr.='<li><a id="dev_but_'.$id.'" '.$class.'" href="'.$button['url'].'">'.$button['title'].'</a></li>';
    $id++;
  }
  
  return $buttonstr;
}

function sa_dev_menu_hook(){
  GLOBAL $SA_DEV_BUTTONS;
  $SA_DEV_BUTTONS[] = array('title'=>'Hooked Button off','url'=>'#','on'=>true);
  $SA_DEV_BUTTONS[] = array('title'=>'Hooked Button on','url'=>'#','on'=>false);
}

function get_toggleqstring($arg,$str){
  GLOBAL $SA_DEV_GLOBALS;
  $argstr = $SA_DEV_GLOBALS[$arg] ? 0 : 1;
  return sa_dev_qstring($str,$argstr);
}

function sa_dev_qstring($arg=null,$value=null,$qstring=null){
  // add or remove arg from querystring, optional user querystring
  // null value removes arg from querystring
  $query_string = array();
  if($qstring==null) $qstring = $_SERVER['QUERY_STRING'];
  parse_str($qstring, $query_string);  
  if(!empty($arg)) $query_string[$arg] = $value;
  $new_str = http_build_query($query_string);
  return $new_str;
}

function sa_dev_executeheader(){
  GLOBAL $PLUGIN_ID, $PLUGINPATH, $owner;

  # debugLog("sa_dev_executeheader");
  
  $regscript = $owner."register_script";
  $regstyle  = $owner."register_style";
  $quescript = $owner."queue_script";
  $questyle  = $owner."queue_style";

  $regstyle($PLUGIN_ID, $PLUGINPATH.'css/sa_dev_style.css', '0.1', 'screen');
  $questyle($PLUGIN_ID,GSBOTH);   
}

function sa_dumpHooks(){
	global $plugins;
    
  debugTitle('Dumping active hooks');
  
  foreach ($plugins as $hook)	{
    if($hook['function'] == 'createSideMenu'){
      debugPair($hook['hook'],$hook['args'][1]);
    }  
  }
}

function debugTitle($title,$h=3){
  debugLog("<h$h>$title</h$h>");
}

function debugPair($key,$value){
  debugLog("<b>$key</b> -> $value");
}


function sa_debugConsole(){  
  # // tie to debugmode deprecated
  # if(defined('GSDEBUG') and !pageIsFrontend()) return;
    
  global $GS_debug;            
		echo '<script type="text/javascript">'."\n";    
		echo '$(document).ready(function() {'."\n";    
    echo '$("h2:contains(\''. i18n_r('DEBUG_CONSOLE') .'\'):not(\'#sa_debug_title\')").remove();';
    echo '});';
    echo '</script>';
    
    echo '<div id="sa_gsdebug-wrapper">
    <div class="sa_gsdebug-wrap">
    <span id="sa_debug_sig">sa_development</span>
    <h2 id="sa_debug_title">'.i18n_r('DEBUG_CONSOLE').'</h2>
    ';
    
    echo sa_debugMenu();
    
    echo'<div id="sa_gsdebug">';
       
    echo '<pre>';
    if(count($GS_debug) == 0){
      echo('Log is empty');
    }  
    else{
      foreach ($GS_debug as $log){
        echo($log);
      }
    }
    echo '</pre>';
    echo '</div></div></div>';
}

function sa_showingHooks(){
  // are we showing hooks
  GLOBAL $SA_DEV_GLOBALS;
  return $SA_DEV_GLOBALS['show_hooks_front'] || $SA_DEV_GLOBALS['show_hooks_back'];
}

function sa_bmarkingHooks(){
  // are we bmarking hooks
  GLOBAL $SA_DEV_GLOBALS;  
  return $SA_DEV_GLOBALS['bmark_hooks_front'] || $SA_DEV_GLOBALS['bmark_hooks_back'];
}

function sa_initHookDebug(){
  // add hooks for showing and bmarking them
  GLOBAL $SA_DEV_GLOBALS, $FRONT_END_HOOKS, $BACK_END_HOOKS; 

  if(sa_bmarkingHooks()){
    debugTitle('Debugging Hooks');
  }  
    
  
  if(sa_showingHooks() || sa_bmarkingHooks()){
    foreach($FRONT_END_HOOKS as $key=>$value){
      if($SA_DEV_GLOBALS['bmark_hooks_front']) add_action($key, 'sa_bmark_hook_debug');
      if($SA_DEV_GLOBALS['show_hooks_front'])  add_action($key, 'sa_echo_hook');
    }

    foreach($BACK_END_HOOKS as $key=>$value){
      if($SA_DEV_GLOBALS['bmark_hooks_back']) add_action($key, 'sa_bmark_hook_debug');
      if($SA_DEV_GLOBALS['show_hooks_back'])  add_action($key, 'sa_echo_hook');  
    }
  }
}

function sa_get_hook_id(){
  // get hook callee from backtrace, since hooks dont identify themselves to their callouts.
  $bt = debug_backtrace();
  foreach($bt as $func){
    # echo '<pre>' . print_r($func,true) . "</pre>";
    if($func['function'] == 'exec_action'){
      # echo '<pre>' . print_r($func,true) . "</pre>";
      return $func['args'][0];
    }
  }
}


function sa_debug_backtrace($skip = 1){
    $traces = debug_backtrace();
    # _debugLog($traces);
    $ret = array();
    foreach($traces as $i => $call){
        if ($i < $skip) {
            continue;
        }

        if (!isset ($call['file']))
        {
            $call['file'] = '';
        }

        if (!isset ($call['line']))
        {
            $call['line'] = '';
        }        
        
        $object = '';
        if (isset($call['class'])) {
            $object = $call['class'].$call['type'];
            if (is_array($call['args'])) {
                foreach ($call['args'] as &$arg) {
                    get_arg($arg);
                }
            }
        }        

        
        $ret[] = '<span style="color:#888"><span class="">#'.str_pad($i - $skip, 3, ' ') . '</span>'
        .'<span class="cm-keyword">' . $object.$call['function'] . '</span>'
        .'<span class="cm-bracket-2">(</span>'
        .'<span class="cm-meta">' . arr_to_csv_line($call['args']) .'</span>'
        .'<span class="cm-bracket-2">)</span>'
        .'<span class="cm-comment"> called at </span>'
        .'<span class="cm-bracket-2">[</span>'
        .'<span class="cm-function" title="'.$call['file'].'">'. sa_get_path_rel($call['file']) .'</span>'
        .':'
        .'<span class="cm-string">'. $call['line'] .'</span>'
        .'<span class="cm-bracket-2">]</span>' . '</span>';
    }

    return implode("\n",$ret);
}

function get_arg(&$arg) {
    if (is_object($arg)) {
        $arr = (array)$arg;
        $args = array();
        foreach($arr as $key => $value) {
            if (strpos($key, chr(0)) !== false) {
                $key = '';    // Private variable found
            }
            $args[] =  '['.$key.'] => '.get_arg($value);
        }

        $arg = get_class($arg) . ' Object ('.implode(',', $args).')';
    }
}

function sa_btprint() 
{   
    return sa_debug_backtrace();
} 

function arr_to_csv_line($arr) {
    $line = array();
    foreach ($arr as $v) {
        $line[] = is_array($v) ? 'array(' . arr_to_csv_line($v) . ')' : '"' . str_replace('"', '""', $v) . '"';
    }
    return implode(",", $line);
}


function sa_echo_hook(){
  // echoes hooks onto pages
  GLOBAL $FRONT_END_HOOKS, $BACK_END_HOOKS;
  $all_hooks = array_merge($FRONT_END_HOOKS, $BACK_END_HOOKS);
  $hook_id = sa_get_hook_id();
  echo '<span style="background-color:#FFCCCC;font-size:12px;color:000;border:1px solid #CCC;padding:2px;margin:2px" title="' . $all_hooks[$hook_id] . '">hook: '.$hook_id.'</span>';
}

function sa_bmark_hook_debug(){
  // benchmark hook call times to debug console
  sa_bmark_debug(sa_get_hook_id());
}

function sa_bmark_hook_print(){
  // benchmark hook call times to page
  sa_bmark_print(sa_get_hook_id());
}

class StopWatch { 
    public $total; 
    public $time; 
    
    public function __construct() { 
        $this->total = $this->time = microtime(true); 
    } 
    
    public function clock() { 
        return -$this->time + ($this->time = microtime(true)); 
    } 
    
    public function elapsed() { 
        return microtime(true) - $this->total; 
    } 
    
    public function reset() { 
        $this->total=$this->time=microtime(true); 
    } 
} 

function sa_bmark_print($msg){
    GLOBAL $stopwatch;
    echo("<span id=\"pagetime\">bmark: " . $msg . ": " . round($stopwatch->clock(),5) . " / " . round($stopwatch->elapsed(),5) ." seconds</span>"); 
}

function sa_bmark_debug($msg = ""){
    GLOBAL $stopwatch;
    debugLog('<h3 class="sad_bmark"><span class="sad_key">bmark</span> : ' . number_format(round($stopwatch->elapsed(),5),5) . "<b> &#711;</b>" . number_format(round($stopwatch->clock(),5),5) . " " . $msg . '</h3>');
}

function _debugLog(){
  debugLog(vdump(func_get_args()));
}

function vdump($args){
    
    if(isset($args) and gettype($args)!='array'){
      $args = func_get_args();
      $numargs = func_num_args();      
    }else{
      $numargs = count($args);
    }   
        
    isset($args[0]) ? $arg1 = $args[0] : $arg1=''; 
    
    $backtrace = debug_backtrace();
    $file = $backtrace[1]['file'];
    $line = $backtrace[1]['line'];
    $code = file($file);    
    $codeline = trim($code[$line-1]);
    
    # debugLog($codeline);
        
    #$argnames = preg_replace('/'. __FUNCTION__ .'\((.*)\)\s?;/',"$1",$codeline);
    $argnames = preg_replace('/_debugLog\((.*)\)\s?;/',"$1",$codeline);
    $argnames = explode(',',$argnames);
    $argn = 0;  
        
    $str = "";
            
    if($numargs > 1 || ( $numargs == 1 and gettype($arg1)=='array') ){
      // if multiple arguments or an array, we add a header for the rows
      $str.=('<h3 title="(' . sa_get_path_rel($file) . ' ' . $line . ')">'.htmlspecialchars($codeline).'</h3>');
    }
    elseif($numargs == 1 and gettype($arg1)=='string' and strpos($argnames[0],'$') === false){
      // if multiple arguments or an array, we add a header for the rows
      $str=('<span title="(' . sa_get_path_rel($file) . ' ' . $line . ')">'.$arg1.'</span>');
      return $str;
    }    
    elseif($numargs == 0){
      $str.=('<h3 title="(' . sa_get_path_rel($file) . ' ' . $line . ')">'. htmlspecialchars($codeline).'</h3>');
      $str.= '<b>Backtrace</b> &rarr;<br />';
      $str.= nl2br(sa_debug_backtrace(2));    
      return $str;
    }
    else{
      // we add a slight divider for single line traces
      $str.="<HR>";
    }
        
    ob_start();
    
      foreach ($args as $arg){
        # if($argn > 0) print("\n");
        print('<b>' . trim($argnames[$argn]) . "</b> &rarr; ");
        if(gettype($arg) == 'array' and count($arg)>0) print "\n";
        var_dump($arg);
        $argn++;
      }  

    $str .= ob_get_contents();
  
    ob_end_clean();

    # debugLog("default output: " . $str."<br/>");        
    
    // added &? to datatypes for new reference output from var_dump
    $str = preg_replace('/=>(\s+)/', ' => ', $str);
    $str = preg_replace('/=> NULL/', '=> <span class="cm-def">NULL</span>', $str);
    $str = preg_replace('/(?!=> )NULL/', '<span class="cm-def">NULL</span>', $str);
    $str = preg_replace('/}\n(\s+)\[/', "}\n\n".'$1[', $str);
    $str = preg_replace('/(&?float|&?int)\((\-?[\d\.\-E]+)\)/',    " <span style='color: #888'>$1</span> <span class='cm-number'>$2</span>", $str);

    $str = preg_replace('/&?array\((\d+)\) {\s+}\n/',            "<span style='color: #888'>array&bull;$1</span> <b style='color: brown'>[]</b>", $str);
    $str = preg_replace('/&?array\((\d+)\) {\n/',                "<span style='color: #888'>array&bull;$1</span> <span class='cm-bracket'>{</span>\n<span class='codeindent'>", $str);
    $str = preg_replace('/&?string\((\d+)\) \"(.*)\"/',          "<span style='color: #888'>str&bull;$1</span> <span class='cm-string'>'$2'</span>", $str);
    $str = preg_replace('/\[\"(.+)\"\] => /',                    "<span style='color:#666'>'<span class='cm-keyword'>$1</span>'</span> &rarr; ", $str);
    $str = preg_replace('/\[(\d+)\] => /',                    "<span style='color:#666'>[<span class='cm-keyword'>$1</span>]</span> &rarr; ", $str);
    $str = preg_replace('/&?object\((\S+)\)#(\d+) \((\d+)\) {\s+}\n/', "<span style='color: #888'>obj&bull;$2</span> <span class='cm-keyword'>$1[$3]</span> <span class='cm-keyword'>{}</span>", $str);
    $str = preg_replace('/&?object\((\S+)\)#(\d+) \((\d+)\) {\n/', "<span style='color: #888'>obj&bull;$2</span> <span class='cm-keyword'>$1[$3]</span> <span class='cm-keyword'>{</span>\n<span class='codeindent'>", $str);
    $str = str_replace('bool(false)',                          "<span style='color:#888'>bool&bull;</span><b style='color: red'>false</b>", $str);
    $str = str_replace('&bool(false)',                          "<span style='color:#888'>bool&bull;</span><b style='color: red'>false</b>", $str);
    $str = str_replace('bool(true)',                           "<span style='color:#888'>bool&bull;</span><b style='color: green'>true</b>", $str);
    $str = str_replace('&bool(true)',                           "<span style='color:#888'>bool&bull;</span><b style='color: green'>true</b>", $str);
    $str = preg_replace('/}\n/',                "</span>\n<span class='cm-bracket'>}</span>\n", $str);
    $str = str_replace("\n\n","\n",$str);
    # if($argn == 1) $str = str_replace("\n","",$str);
    $str = trim($str);
          
    return nl2br($str);   
}


function sa_get_path_rel($path){
  return str_replace($_SERVER['DOCUMENT_ROOT'],'',$path);
}

function sa_debugtest(){

  // vdump($plugins); 
  
  // object to console
  $book               = new stdClass;
  $book->title        = "Harry Potter and the Prisoner of Azkaban";
  $book->author       = "J. K. Rowling";
  $book->publisher    = "Arthur A. Levine Books";
  $book->amazon_link  = "http://www.amazon.com/dp/0439136369/";
    
  $tstring = "a string";
  $tint = 1;
  $tfloat = 1.2;
  $tdbl = 7E-10;
  $tnull = null;
  $tarray = array();
  
  $testary = array(
  'int' => $tint,
  'float' => $tfloat,
  'double' => $tdbl,
  'string' => $tstring,
  'null' => $tnull,
  'empty array' => $tarray,
  'array' => array(  
    'int' => $tint,
    'float' => $tfloat,
    'string' => $tstring,
    'nested array' => array(1,2,3),
  ),
  'bool true' => true,
  'bool false' => false,  
  'object' => new stdClass,
  );  
  
  _debugLog($testary);
  _debugLog($tstring);
  _debugLog($tint);
  _debugLog($tint,$tfloat,$tdbl,$tstring,$tnull,$tarray);
  _debugLog($tstring);
  _debugLog('A string of text');
  _debugLog('A string of text');
  _debugLog('A string of text');
  _debugLog('A string of text');
  _debugLog('A string of text');
  _debugLog('A string of text');
  _debugLog($tint);
  _debugLog($tfloat);
  _debugLog($tnull);
  
  #sa_bmark_debug('vdump BEGIN');
  #for($i=0;$i<50;$i++){ vdump($_SERVER);}
  #sa_bmark_debug('vdump END');        

_debugLog(nl2br("  
<span class=cm-keyword>keyword{color: #708; font-weight: bold;}</span>
<span class=cm-atom>atom{color: #219;}</span>
<span class=cm-number>number {color: #164; font-weight: bold;}</span>
<span class=cm-def>def {color: #00f; font-weight: bold;}</span>
<span class=cm-variable>variable {color: black;}</span>
<span class=cm-variable-2>variable-2 {color: #05a;}</span>
<span class=cm-variable-3>variable-3 {color: #0a5;}</span>
<span class=cm-property>property {color: black;}</span>
<span class=cm-operator>operator {color: black;}</span>
<span class=cm-comment>comment {color: #a50;}</span>
<span class=cm-string>string {color: #a11; font-weight: bold;}</span>
<span class=cm-meta>meta {color: #555;}</span>
<span class=cm-error>error {color: #f00;}</span>
<span class=cm-qualifier>qualifier {color: #555;}</span>
<span class=cm-builtin>builtin {color: #30a;}</span>
<span class=cm-bracket>bracket {color: #a11;}</span>
<span class=cm-tag>tag {color: #170;}</span>
<span class=cm-attribute>attribute {color: #00c; font-weight:bold;}</span>
<span class=cm-function>function {color: #219;}</span>
<span class=cm-function-2>function-2 {color: #219; font-weight:bold;}</span>
<span class=cm-function-3>function-3 {color: #219; font-weight:bold;}</span>
"));  

_debugLog('test');
_debugLog('test',myfunc('test','test'));
  
}      

function myfunc($a,$b){
  echo $a;
}

?>
